repos:
  - repo: https://github.com/pre-commit/pre-commit-hooks
    rev: v5.0.0
    hooks:
      - id: end-of-file-fixer
      - id: trailing-whitespace
      - id: check-ast
      - id: check-yaml
        # ci.yml uses the docker-compose !reset thing which isn't recognized.
        # I think it could be fixed but I don't have time for this right now
        exclude: end-to-end-test/docker-compose.ci.yml
      - id: check-json
      - id: check-toml
      - id: debug-statements
      - id: check-merge-conflict
  - repo: local
    hooks:
      - name: make-migrations
        id: make-migrations
        files: "/models(.py|/.*)"
        pass_filenames: false
        entry: env NIXPKGS_ALLOW_BROKEN=1 nix develop --extra-experimental-features 'nix-command flakes' --impure -c env PYTHONDEVMODE= invoke make-migrations
        language: system
      - name: feature-flag-guardrail
        id: feature-flag-guardrail
        files: "/feature_flags.py"
        pass_filenames: false
        entry: invoke feature-flag-guardrail
        language: system
      - id: ruff
        name: ruff
        description: "Run 'ruff' for extremely fast Python linting"
        entry: ruff check --force-exclude --fix
        language: system
        types_or: [python, pyi]
        require_serial: true
        exclude: "(/settings/(dev|test|prod).py$|/migrations/.*\\.py$)"

      - id: ruff-format
        name: ruff-format
        description: "Run 'ruff format' for extremely fast Python formatting"
        entry: ruff format --force-exclude
        language: system
        types_or: [python, pyi]
        require_serial: true
        exclude: "/migrations/.*\\.py$"
  - repo: https://github.com/pre-commit/mirrors-prettier
    rev: "v3.1.0"
    hooks:
      - id: prettier
        exclude: ^(flake.lock|src/.*/templates/)$
  - repo: https://github.com/djlint/djLint
    rev: v1.36.4 # let's keep it in sync with djlint --version
    hooks:
      - id: djlint-reformat-django
      - id: djlint-django
  - repo: https://github.com/PyCQA/bandit
    rev: "1.8.3"
    hooks:
      - id: bandit
        entry: "bandit --ini .bandit"
        exclude: "(^deploy/|(^|/)tasks.py|/settings/(dev|test).py$|/tests?/|/conftest.py$)"
